unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ShlObj,
  StdCtrls, ActiveX, ComObj;

type
  TForm1 = class(TForm)
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    DirDesktop : String;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  ItemIDList :  PItemIDList;
begin
  SetLength(DirDesktop,MAX_PATH);
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_DESKTOPDIRECTORY,
    ItemIDList);
  SHGetPathFromIDList(ItemIdList,PChar(DirDesktop));
  SetLength(DirDesktop,StrLen(PChar(DirDesktop)));
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ShellLink : IShellLink;
  PersistFile : IPersistFile;
  NomeLnk : WideString;
begin
// cria interface IShellLink
  ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
// cria interface IPersistFile
  PersistFile := ShellLink as IPersistFile;
// preenche dados de IShellLink
  with ShellLink do begin
    SetDescription(PChar(Edit1.Text));
    SetPath(PChar(Edit2.Text));
    SetArguments(PChar(Edit3.Text));
    SetWorkingDirectory(PChar(ExtractFilePath(Edit2.Text)));
  end;
  NomeLnk := DirDesktop+'\'+ChangeFileExt(Edit1.Text,'.lnk');
// salva atalho
  PersistFile.Save(PWideChar(NomeLnk),False);
end;

end.
